#define periodLock 3000
#define timerStartup 0
#define distanceReadCol 15
#define periodSanara 500
#define HzSoundWelcome 0
#define HzMnSoundWelcome 1
#define text_max 5
String text[text_max] = {"My name's CHDWin", "I love you", "Security", "I have computer", "We family!"};




#include <LiquidCrystal.h>
#include <GyverEncoder.h>
#include <EEPROM.h>
#include <Ultrasonic.h>
#include <GyverTimers.h>

LiquidCrystal lcd(7, 6, 5, 4, 3, 2);
Encoder enc(A1, A2, A3);
Ultrasonic sanara(A4, A5);
#define soundDevice A0

byte punt = 1;
byte punt_min = 1;
byte punt_max = 5;
boolean flag = false;
byte sec = 0;
byte min = 0;
byte timer_punt = 1;
byte timer_tick_upd = 0;
byte text_id = 0;
byte guess_punt = 1;
byte guessNumber = 1;
boolean lock = true;
boolean lock_full = false;
boolean guessed = false;
boolean isTickEncoder = false;
boolean isExitProgram = false;
boolean isOpenProgram = false;
boolean isTimeoutTimerSound = false;
boolean isTickProgram = false;
byte lock_full_stap = 1;
uint64_t timer_lock_full = 0;
uint64_t timer_lock = 0;
uint64_t isTimerSound = 0;
byte lock_full_sec = 5;
String animation_cadr[12] = {"o", "op", "ope", "open", "open-", "open->", " pen->", "  en->", "   n->", "    ->", "     >", "      "};
byte lock_check[5] = {5, 9, 15, 45, 50};

ISR(TIMER1_A) {
  if (isTickEncoder) {
    volatile static boolean isPlaySoundTickEncoder;
    if (isPlaySoundTickEncoder == false) {
      isPlaySoundTickEncoder = true;
      isTimerSound = millis();
      tone(soundDevice, 400);
    } else {
      if (millis() - isTimerSound >= 50) {
        noTone(soundDevice);
        isPlaySoundTickEncoder = false;
        isTickEncoder = false;
      }
    }
  }
  if (isOpenProgram) {
    volatile static boolean isPlaySoundOpenProgram;
    if (isPlaySoundOpenProgram == false) {
      isPlaySoundOpenProgram = true;
      isTimerSound = millis();
      tone(soundDevice, 600);
    } else {
      if (isPlaySoundOpenProgram and millis() - isTimerSound >= 50) {
        noTone(soundDevice);
        isPlaySoundOpenProgram = false;
        isOpenProgram = false;
      }
    }
  }
  if (isExitProgram) {
    volatile static boolean isPlaySoundExitProgram;
    if (isPlaySoundExitProgram == false) {
      isPlaySoundExitProgram = true;
      isTimerSound = millis();
      tone(soundDevice, 200);
    } else {
      if (isPlaySoundExitProgram and millis() - isTimerSound >= 50) {
        noTone(soundDevice);
        isPlaySoundExitProgram = false;
        isExitProgram = false;
      }
    }
  }
  if (isTimeoutTimerSound) {
    volatile static boolean isPlaySoundTimeoutTimer;
    if (isPlaySoundTimeoutTimer == false and millis() - isTimerSound >= 250) {
      isPlaySoundTimeoutTimer = true;
      isTimerSound = millis();
      tone(soundDevice, 600);
    } else {
      if (isPlaySoundTimeoutTimer and millis() - isTimerSound >= 50) {
        noTone(soundDevice);
        isPlaySoundTimeoutTimer = false;
        isTimerSound = millis();
      }
    }
  }
  if (isTickProgram) {
    volatile static boolean isPlaySoundTickProgram;
    if (isPlaySoundTickProgram == false) {
      isPlaySoundTickProgram = true;
      isTimerSound = millis();
      tone(soundDevice, 1500);
    } else {
      if (isPlaySoundTickProgram and millis() - isTimerSound >= 50) {
        noTone(soundDevice);
        isPlaySoundTickProgram = false;
        isTickProgram = false;
        isTimerSound = millis();
      }
    }
  }
}

void setup() {
  Timer1.enableISR(CHANNEL_A);

  lcd.begin(16, 2);
  enc.setType(TYPE2);
  for (byte i = 0; i < 5; i++) {
    if (EEPROM.read(lock_check[i]) == 'l') {
      lock_full = true;
    }
  }
  timer_lock = millis();
  startMenu();
  soundStart();
  delay(timerStartup * 1000);
  static uint32_t upd_full_lock;
  if (millis() - upd_full_lock >= 200 and lock_full) {
    upd_full_lock = millis();
    lock_full_p();
  }
}

void loop() {
  // put your main code here, to run repeatedly:
  tick();
}

void clearDisplay() {
  for (byte i = 0; i < 16; i++) {
    for (byte j = 0; j < 2; j++) {
      lcd.setCursor(i, j);
      lcd.print(' ');
    }
  }
}

void startMenu() {
  clearDisplay();
  lcd.setCursor(4, 0);
  lcd.print("Welcome!");
  lcd.setCursor(1, 1);
  lcd.print("C*Win ver. 2.1");
}

void soundStart() {
  tone(soundDevice, 500 - HzSoundWelcome);
  delay(500);
  noTone(soundDevice);
  tone(soundDevice, 1000 - (HzSoundWelcome * HzMnSoundWelcome));
  delay(500);
  noTone(soundDevice);
  tone(soundDevice, 500 - HzSoundWelcome);
  delay(500);
  noTone(soundDevice);
  tone(soundDevice, 200 - HzSoundWelcome);
  delay(500);
  noTone(soundDevice);
  tone(soundDevice, 500 - HzSoundWelcome);
  delay(500);
  noTone(soundDevice);
  tone(soundDevice, 1000 - (HzSoundWelcome * HzMnSoundWelcome));
  delay(500);
  noTone(soundDevice);
  tone(soundDevice, 500 - HzSoundWelcome);
  delay(500);
  noTone(soundDevice);
}

void drawMenu() {
  static uint32_t upd_timer = 0;
  if (millis() - upd_timer >= 250) {
    upd_timer = millis();
    clearDisplay();
    if (punt == 1) {
      lcd.setCursor(10, 1);
      lcd.print("next->");
    } else if (punt == punt_max) {
      lcd.setCursor(0, 1);
      lcd.print("<-back");
    } else {
      lcd.setCursor(0, 1);
      lcd.print("<-back");
      lcd.setCursor(10, 1);
      lcd.print("next->");
    }

    switch (punt) {
      case 1:
        lcd.setCursor(5, 0);
        lcd.print("Timer");
        break;
      case 2:
        lcd.setCursor(3, 0);
        lcd.print("Stopwatch");
        break;
      case 3:
        lcd.setCursor(6, 0);
        lcd.print("Text");
        break;
      case 4:
        lcd.setCursor(4, 0);
        lcd.print("Distance");
        break;
      case 5:
        lcd.setCursor(0, 0);
        lcd.print("Guess the number");
        break;
    }
  }
}

void encoder() {
  enc.tick();
  if (enc.isRight()) {
    if (!flag) {
      if (punt < punt_max and !lock) {
        punt++;
      }
    }
    if (flag) {
      if (punt == 1 and timer_punt == 1) {
        sec++;
        if (sec == 60) {
          min++;
          sec = 0;
        }
      }
      if (punt == 3) {
        byte max = text_max;
        max--;
        if (text_id < max) {
          text_id++;
        }
      }
      if (punt == 5 and guessNumber != 9) {
        guessNumber++;
      }
    }
    if (lock) {
      lock = false;
      flag = false;
    }
    if (lock_full) {
      lock_full = false;
      punt = 1;
      flag = false;
      for (byte i = 0; i < 5; i++) {
        EEPROM.write(lock_check[i], 'u');
      }
    }
    timer_lock = millis();
    isTickEncoder = true;
  }
  if (enc.isLeft()) {
    if (!flag and !lock and !lock_full) {
      if (punt > punt_min) {
        punt--;
      }
    }
    if (flag and !lock and !lock_full) {
      if (punt == 1 and timer_punt == 1) {
        if (sec == 0 and min != 0) {
          min--;
          sec = 59;
          return;
        }
        if (sec != 0) {
          sec--;
        }
      }
      if (punt == 3) {
        if (text_id > 0) {
          text_id--;
        }
      }
      if (punt == 5 and guessNumber != 1) {
        guessNumber--;
      }
    }
    timer_lock = millis();
    isTickEncoder = true;
  }
  if (enc.isRightH()) {
    if (flag and !lock and !lock_full) {
      if (punt == 1 and timer_punt == 1) {
        min++;
      }
    }
    timer_lock = millis();
  }
  if (enc.isLeftH()) {
    if (flag and !lock and !lock_full) {
      if (punt == 1 and timer_punt == 1) {
        if (min != 0) {
          min--;
        }
      }
    }
    timer_lock = millis();
  }
  if (enc.isClick()) {
    if (!flag and !lock) {
      flag = !flag;
      sec = 0;
      min = 0;
      timer_punt = 1;
      isOpenProgram = true;
      return;
    }
    if (flag and !lock) {
      if (punt == 1) {
        if (timer_punt == 1) {
          timer_punt++;
        }
      }
      if (punt == 5 and guess_punt == 1) {
        if (random(0, 9) == guessNumber) {
          guessed = true;
        } else {
          guessed = false;
        }
        guess_punt++;
      }
    }
    timer_lock = millis();
  }
  if (enc.isHolded()) {
    if (!lock and lock_full) {
      lock_full_stap = 2;
      lcd.clear();
      lcd.setCursor(7, 0);
      lcd.print(lock_full_sec);
      timer_lock_full = millis();
    }
    if (!flag and !lock and !lock_full) {
      lock_full_stap = 1;
      lock_full = true;
      lock_full_sec = 5;
      for (byte i = 0; i < 5; i++) {
        EEPROM.write(lock_check[i], 'l');
      }
    }
    if (flag and !lock and !lock_full) {
      flag = !flag;
      guess_punt = 1;
      guessed = false;
      guessNumber = 1;
      isExitProgram = true;
      if (punt == 1 and timer_punt == 3) {
        isTimeoutTimerSound = false;
      }
    }
    if (lock and !lock_full and !flag) {
      lcd.begin(16, 2);
    }
    timer_lock = millis();
  }
}

void programm() {
  if (flag) {
    if (punt == 1) {
      static uint32_t timer_upd;
      if (millis() - timer_upd >= 100) {
        timer_upd = millis();
        timer();
      }
    }
    if (punt == 2) {
      static uint32_t secunds_upd;
      if (millis() - secunds_upd >= 100) {
        secunds_upd = millis();
        secunds_p();
      }
    }
    if (punt == 3) {
      static uint32_t text_upd;
      if (millis() - text_upd >= 100) {
        text_upd = millis();
        text_p();
      }
    }
    if (punt == 4) {
      static uint32_t distance_upd;
      if (millis() - distance_upd >= 250) {
        distance_upd = millis();
        distanceSanara();
      }
    }
    if (punt == 5) {
      static uint32_t guess_upd;
      if (millis() - guess_upd >= 250) {
        guess_upd = millis();
        guessNumberF();
      }
    }
  }
}

void timer() {
  if (timer_punt == 1) {
    static uint32_t upd_timer_1;
    if (millis() - upd_timer_1 >= 100) {
      upd_timer_1 = millis();
      clearDisplay();
      lcd.setCursor(4, 0);
      lcd.print("Timer on");
      lcd.setCursor(5, 1);
      if (min < 10) {
        lcd.print("0");
      }
      lcd.print(min);
      lcd.print(":");
      if (sec < 10) {
        lcd.print("0");
      }
      lcd.print(sec);
    }
  }
  if (timer_punt == 2) {
    if (timer_tick_upd != 9) {
      timer_tick_upd++;
    } else {
      timer_tick_upd = 0;
      if (sec == 0) {
        min--;
        sec = 59;
      } else {
        sec--;
      }
      isTickProgram = true;
    }

    clearDisplay();
    lcd.setCursor(5, 0);
    lcd.print("Timer");
    lcd.setCursor(5, 1);
    if (min < 10) {
      lcd.print("0");
      lcd.print(min);
    } else {
      lcd.print(min);
    }
    lcd.print(':');
    if (sec < 10) {
      lcd.print("0");
      lcd.print(sec);
    } else {
      lcd.print(sec);
    }

    if (sec == 0 and min == 0) {
      timer_punt++;
    }
  }
  if (timer_punt == 3) {
    clearDisplay();
    lcd.setCursor(4, 0);
    lcd.print("Time out");
    isTimeoutTimerSound = true;
  }
}

void secunds_p() {
  static byte upd_sec;
  if (upd_sec != 10) {
    upd_sec++;
  } else {
    upd_sec = 0;
    sec++;
    if (sec == 60) {
      min++;
      sec = 0;
    }
    isTickProgram = true;
    clearDisplay();
    lcd.setCursor(3, 0);
    lcd.print("Stopwatch");
    lcd.setCursor(5, 1);
    if (min < 10) {
      lcd.print("0");
      lcd.print(min);
    } else {
      lcd.print(min);
    }
    lcd.print(':');
    if (sec < 10) {
      lcd.print("0");
      lcd.print(sec);
    } else {
      lcd.print(sec);
    }
  }
}
void text_p() {
  clearDisplay();
  lcd.setCursor(6, 0);
  lcd.print("Text");
  lcd.setCursor(0, 1);
  lcd.print(text[text_id]);
}

void distanceSanara() {
  static uint64_t updSanara;
  if (millis() - updSanara >= periodSanara) {
    updSanara = millis();
    isTickProgram = true;
    int distance = 0;
    for (byte i = 0; i < distanceReadCol; i++) {
      distance += sanara.read();
    }
    distance = distance / distanceReadCol;
    clearDisplay();
    lcd.setCursor(4, 0);
    lcd.print("Distance");
    lcd.setCursor(5, 1);
    if (distance < 10) {
      lcd.print("00");
      lcd.print(distance);
    } else if (distance < 100) {
      lcd.print("0");
      lcd.print(distance);
    } else {
      lcd.print(distance);
    }
    lcd.print(" CM");
  }
}

void guessNumberF() {
  if (guess_punt == 1) {
    clearDisplay();
    lcd.setCursor(1, 0);
    lcd.print("Your number: ");
    lcd.print(guessNumber);
  }
  if (guess_punt == 2) {
    if (guessed) {
      clearDisplay();
      lcd.setCursor(3, 0);
      lcd.print("Correctly");
    } else {
      clearDisplay();
      lcd.setCursor(2, 0);
      lcd.print("Incorrectly");
    }
  }
}

void tick() {
  encoder();
  if (!lock and !lock_full) {
    programm();
    lockMec();
    static uint32_t upd_menu;
    if (millis() - upd_menu >= 200 and !flag) {
      drawMenu();
    }
  } else if (!lock_full and lock) {
    static uint32_t upd_lock;
    if (millis() - upd_lock >= 200) {
      upd_lock = millis();
      lock_p();
    }
  } else {
    static uint32_t upd_full_lock;
    if (millis() - upd_full_lock >= 200) {
      upd_full_lock = millis();
      lock_full_p();
    }
  }
}

void lockMec() {
  if (millis() - timer_lock >= periodLock and !flag and !lock and !lock_full) {
    timer_lock = millis();
    lock = true;
  }
}

void lock_p() {
  clearDisplay();
  lcd.setCursor(5, 0);
  lcd.print("Hello!");
  static uint8_t animation;
  if (animation == 12) animation = 0;
  lcd.setCursor(10, 1);
  lcd.print(animation_cadr[animation]);
  animation++;
}

void lock_full_p() {
  if (lock_full_stap == 1) {
    clearDisplay();
    lcd.setCursor(5, 0);
    lcd.print("Hello!");
    lcd.setCursor(3, 1);
    lcd.print("full lock");
  }
  if (lock_full_stap == 2) {
    if (millis() - timer_lock_full >= 1000) {
      timer_lock_full = millis();
      lock_full_sec--;
      clearDisplay();
      lcd.setCursor(7, 0);
      lcd.print(lock_full_sec);
    }
    static uint8_t animation;
    if (animation == 12) animation = 0;
    lcd.setCursor(10, 1);
    lcd.print(animation_cadr[animation]);
    animation++;
    if (lock_full_sec == 0) {
      lock_full_stap = 1;
      lock_full_sec = 5;
    }
  }
}
